sealed abstract class Exp {
	def eval:Int = this match {
		case Const(c:Int) => c
		case Add(a:Exp,b:Exp) => a.eval + b.eval
		case Mul(a:Exp,b:Exp) => a.eval * b.eval
	}
}

case class Const(c:Int) extends Exp
case class Add(a:Exp,b:Exp) extends Exp
case class Mul(a:Exp,b:Exp) extends Exp
